# Inteligr8 ACS Attribute Cleaner Platform Module Library

This is an Alfresco Content Services platform module that provides attribute service tools at the bootstrap and runtime of ACS.

# Features

You can enable this module by installing it and explicitly setting the following property:

```ini
inteligr8.attrcleaner.enabled=true
```

You may also change the log level of any output from this module using the following property (default is `info`):

```ini
inteligr8.attrcleaner.log-level=info
```

## Query

At startup, you can output the contents of the ACS attribute service by setting the scope of this feature (default is `jmx`):

```ini
inteligr8.attrcleaner.feature.list.scope=jmx
```

Here are the possible values:

| Scope            | Description |
| ---------------- | ----------- |
| `none`           | Do not list any attributes from the attribute service. |
| `jmx`            | List all JMX attributes (`.PropertyBackedBeans`) from the attribute service. |
| `shard-registry` | List all shard registry attributes (`.SHARD_STATE` and `.SHARD_SUBSCRIPTION`) from the attribute service. |
| `custom`         | List all shard registry attributes in the attribute service that match the `inteligr8.attrcleaner.feature.list.keys` value. |

When using `custom`, you can query for certain keys using the following:

```ini
inteligr8.attrcleaner.feature.list.keys=\.SHARD\_STATE,\.SHARD\_SUBSCRIPTION
```

The keys are expected to be **comma delimited** and **regular expression** patterns.

# Clear

At startup, you can clear the contents of the ACS attribute service by setting the scope of this feature (defualt is `none`).  See the section on *Query* for details.  Everything is the same, except the property names are as follows:

```ini
inteligr8.attrcleaner.feature.clear.scope=
inteligr8.attrcleaner.feature.clear.keys=
```
